# Convoworks Prototype #

## [Releases]

### v1.16 ###

**2020-11-10**

* **Breaking change!!!** `AbstractPackageDefinition::_initDefintions()` now returns array!
* additional processor in media block
* changed build scripts to support relative urls
* in memory cache util class
* added ability to mark required slots in intent readers 
* editor comment can't be chosen by Element Randomizer
* add ability to change where params are stored in HTTP element
* update help inside Convoworks
* context elements no longer in toolbar, now in dropdown menu
* migrated more views to new design
* improved buttons
* add single block preview toggle

### v1.15.1 Slot names fix ###

**2020-11-02**

* when defining intents, use existing slot name for the same entity type

### v1.15 Editor UI overhaul ###

**2020-10-29**

* overhauled editor UI to match new design
* implemented ability to delete service, local only or completely
* new intent and entity editors
* updated help files for all core elements
* can search elements in toolbox
* fix amazon configuration sticking if skill creation fails
* disallow config submit if form is invalid
* mysqli available in docker

### v1.14.2 Not required convo/v1 in rest routing ###

**2020-10-26**

* `convo/v1` is no longer used in PHP src when building rest urls so it can be mounted at any routing that hosted app wants to


### v1.14.1 Convigurable rest public url ###

**2020-10-10**

* `rest_public` is no longer used in PHP src when building rest urls  the new config param `CONVO_PUBLIC_REST_BASE_URL` encorprates it while the old `CONVO_BASE_URL` is actually public web base url


### v1.14 The Docker Release ###

**2020-10-08**

* Docker is now included as a development environment
    * Refer to `README.md` for setup instructions, and some things to note.
* configuration constants moved to separate REST endpoint at `rest_admin/config-options`
* Simple Text Element can now append text to the preceding sentence
* fixed import/export of preview variables and configurations
* fixed missing dependencies when importing CW skill with different included packages
* added support for interfaces in Amazon skill configuration
* fixed conflicting config creation when enabling skill on Amazon with existing skill ID
* added support for compressing service params with `gzip`
* service level variables now support complex setting and getting
* included `zef-dev/zef-expression-language` as expression language
* `set_include_path` removed from configs - not needed with PSR-4
* reworked "Add Service" and "Configuration" views to match design
* overhauled help fetching sub-framework
* switched to UI router inside Angular app
* added support for mp3 metadata
* fixes for trivia block element
* created new trivia score element


### v1.13 ###

**2020-08-21**

* added integrations for Facebook Messenger and Viber
* fix duplicated spaces and newlines on text output 
* split user and service packages
* load packages only when needed
* add simple version tagging
* import to develop for any release
* fix not being able to propagate to amazon if skill was live

### v1.12 ###

**2020-07-14**

* fix Amazon session end by exit response
* added service ownership and sharing
* added publishing as owner when adding changes to Amazon or Google
* restrict updating of service meta and platform configurations without service owner
* added gulp build scripts
* copy/paste for components
* implement initial support for catalogs - amazon only
* angularjs 1.8 (run bower update)
* partially implemented new design


### v1.11.1 Http cache ###

**2020-06-18**

* added cache to `HttpQueryElement`. Default disabled - `0`
* fixed dialogflow reprompt text cleanup 


### v1.11 Dialoglfow reprompt and other fixes ###

**2020-06-10**

* fix dialogflow detect intent for webchat
* remove system properties from component workflow
* add configurable home chat
* add ability to mark development, stage and mlive
* add propagate all button 
* fix reprompt for dialogflow
* add support for Alexa emotions
* Add custom `array_shuffle` function to expression provider
* Endpoint URI is now propagated to Amazon
* Media service overhauled, new public endpoint for getting media
* `YesNoProcessor` intents are now included in the overview
* Fragments are now in overview
* Editable service meta
* service version v19 - alexa emotions props defaults
* service version v18 - remove system props from service data

### v1.10.3 Amazon display supported check fix ###

* add check if Alexa device has display supported
* add check if Alexa skill has the Display Interface enabled

### v1.10.2 If string fix ###

* do not use parse boolean in if elements


### v1.10.1 Dialogflow fix ###

* fix missing verificationStatus in user field

### v1.10 Service releases ###

* new configuration section
* new releases & version workflow
* service version 16 - config & meta migrate
* auto display text for amazon devices with display support
* fixed installation id issue on Dialogflow
* function providers moved to package level
* update parts of service's metadata (name, description, owner, admins)
* prefixes now identify entities/intents in packages
* actual service version 17

### v1.9.3 ###

* Http element - catch any exception


### v1.9.2 ###

* add new dialogflow intent ASSISTANT_CANCEL


### v1.9.1 Dialogflow request fix ###

**2020-05-06**

* dump invalid dialogflow request - for later analysis


### v1.9 Rename components ###

**2020-05-06**

* major components rename (fragment, include ...)
* preview service texts
* http element has error handling
* debug in test chat



### v1.8.1 Session start calling fix ###

**2020-04-22**

* session start is now called if there is no last state stored - `isLaunchRequest()` does not work as expected


### v1.8 Intent filters ###

**2020-04-20**

* working with convo intents through filters - not processors
* deprecated components hidden
* intents & entities improvements & list view in GUI
* new services list view
* `GOTO` now runs immediately
* fixed evaluation context & non existing values issue
* current service version is 11

### v1.7.3 Session end fix v2 ###

**2020-04-16**

* save state before executing (might be system)

### v1.7.2 Session end fix ###

**2020-04-14**

* return after session end

### v1.7.1 Alexa Request Validation ###

**2020-04-08**

* added validation for Alexa requests to ensure that the request really came from Alexa

### v1.7 Intent and entities ###

**2020-03-31**

* ability to define convo intents and entities
* ability to define system intents and entities in package
* deploy templates with packages
* cross platform request filters
* multiple processors in process subroutine
* accept multiple components by default (in simple processor, simple if, switch/case ...)
* automatic changes propagation in AUTO mode
* new config value - `CONVO_SYSTEM_CONFIGURATION`

### v1.6.4 Date function in expression language ###

**2020-03-26**

* add date function in expression language

### v1.6.3 Fixes ###

**2020-03-24**

* add `md5` encryption for the session file name generation
* add project id as installation id in dialogflow request
* add support for handling conversation exits in dialogflow

### v1.6.2 suggestions array initialization fix ###

**2020-03-17**

* initialize empty array instead of nothing at all

### v1.6.1 Constructor fix ###

**2020-03-12**

* missing parent constructor call fixed


### v1.6 Visual elements ###

**2020-03-10**

* default block phase in steps view
* json reader core component
* list core component
* card core component
* suggestions dialogflow component
* browse carousel dialogflow component
* service data stored as folder not single json anymore (with automatic upgrade)
* support for service versions and publish state

---

### v1.5 Media player ###

**2020-02-12**

* EU development started
* media player component
* symphny expression evaluation
* reusable processors
* PSR-s 
* DI


---

### v1.4 Jenkins ###

**2019-01-27**

* live config, mongodb dependcy fix


---

### v1.3 Fixes ###

**2018-08-23**

* filter fixes
* additional operators in expression language


---

### v1.2 Zend Framework 2 ###

**2018-08-11**

* instead of including whole ZF1, we are now using ZF2, just http package 
* Do not forget to run `composer update`


---

### v1.1 Filesystem by default ###

**2018-07-22**

* separated cache interface and implemented filesystem cache
* filesystem environment is now default (in _context.example.php)

---

### v1.0 Initial release ###

**2018-07-12**

* Core framework with ability to define own packages
* Admin with visual editor
* Public REST with Amazon and Google support
* Filesystem application environment - for easy quikstart
* MongoDb application environment - more serious

---
