<?php declare(strict_types=1);

namespace Convo\Proto\Pckg\Elements;

class AddToCart extends \Convo\Core\Workflow\AbstractWorkflowComponent implements \Convo\Core\Workflow\IConversationElement
{
    private $_input = [];
    private $_result;
    private $_cart = [];
    
    public function __construct($properties) {
        
        parent::__construct( $properties);
        $this->_input = $properties['input'];
        $this->_result = $properties['result'];
    }
    
    public function read( \Convo\Core\Workflow\IConvoRequest $request, \Convo\Core\Workflow\IConvoResponse $response)
    {
        $this->_logger->debug( 'Raw input ['.$this->_input.']');
        $this->_logger->debug( 'Raw result ['.$this->_result.']');
        
        $input	=   $this->evaluateString( $this->_input);
        $result	=   $this->evaluateString( $this->_result);
        
        $this->_logger->debug( 'Input ['.print_r( $input, true).']');
        $this->_logger->debug( 'var to store ['.$result.']');
        
        $num_products = 0;

        $params = $this->getService()->getServiceParams(\Convo\Core\Params\IServiceParamsScope::SCOPE_TYPE_SESSION);

        if ( empty( $params->getServiceParam( $result)))
        {
            $params->setServiceParam( $result, [
                'count' => 1,
                'cart' => [$input],
            ]);
        }
        
        else 
        {
            $cart = $params->getServiceParam( $result)['cart'];
            
            $num_products = array_push( $cart, $input);
            
            $params->setServiceParam( $result, [
                'count' => $num_products,
                'cart' => $cart,
            ]);
        }  
        
        $this->_logger->debug('Cart products ['.print_r( $params->getServiceParam( $result), true).']');
    }   
    
    // UTIL
    public function __toString()
    {
        return parent::__toString().'['.$this->_input.']';
    }
    
}

?>
